using System;
using System.Data;
using System.Data.SqlClient;
using System.Data.SqlTypes;
using Microsoft.SqlServer.Server;


public partial class StoredProcedures
{
  [Microsoft.SqlServer.Server.SqlProcedure]
  public static void clr_unhandled()
  {
    SqlConnection conn = new SqlConnection("context connection=true");
    SqlCommand cmd = new SqlCommand("delete jobs where job_id =2", conn);
    conn.Open();
    //SqlContext.Pipe.ExecuteAndSend(cmd);
    cmd.ExecuteNonQuery();
  }

  [Microsoft.SqlServer.Server.SqlProcedure]
  public static void clr_rethrow()
  {
    SqlConnection conn = new SqlConnection("context connection=true");
    SqlCommand cmd = new SqlCommand("delete jobs where job_id =2", conn);
    conn.Open();
    try
    {
      SqlContext.Pipe.ExecuteAndSend(cmd);
      //cmd.ExecuteNonQuery();
    }
    catch (SqlException ex)
    {
      // additional error handling goes here
      throw (ex);
    }
  }

  [Microsoft.SqlServer.Server.SqlProcedure]
  public static void clr_raiserror1()
  {
    SqlConnection conn = new SqlConnection("context connection=true");
    SqlCommand cmd = new SqlCommand("delete jobs where job_id =2", conn);
    conn.Open();
    try
    {
      SqlContext.Pipe.ExecuteAndSend(cmd);
      //cmd.ExecuteNonQuery();
    }
    catch (SqlException ex)
    {
      SqlCommand cmd2 = conn.CreateCommand();
      cmd2.CommandText = string.Format("raiserror(50001, 16, 1) with seterror");
      SqlContext.Pipe.ExecuteAndSend(cmd2);
    }
  }

  [Microsoft.SqlServer.Server.SqlProcedure]
  public static void clr_raiserror2()
  {
    SqlConnection conn = new SqlConnection("context connection=true");
    SqlCommand cmd = new SqlCommand("delete jobs where job_id =2", conn);
    conn.Open();
    try
    {
      SqlContext.Pipe.ExecuteAndSend(cmd);
      //cmd.ExecuteNonQuery();
    }
    catch (SqlException ex)
    {
      SqlCommand cmd2 = conn.CreateCommand();
      cmd2.CommandText = string.Format("raiserror(50001, 16, 1) with seterror");
      try
      {
        SqlContext.Pipe.ExecuteAndSend(cmd2);
      }
      catch { }
    }
  }

  [Microsoft.SqlServer.Server.SqlProcedure]
  public static void clr_nested_unhandled()
  {
    SqlConnection conn = new SqlConnection("context connection=true");
    SqlCommand cmd = new SqlCommand("clr_unhandled", conn);
    cmd.CommandType = CommandType.StoredProcedure;
    conn.Open();
    SqlContext.Pipe.ExecuteAndSend(cmd);
    //cmd.ExecuteNonQuery();
  }

  [Microsoft.SqlServer.Server.SqlProcedure]
  public static void clr_nested_reraise()
  {
    SqlConnection conn = new SqlConnection("context connection=true");
    SqlCommand cmd = new SqlCommand("clr_unhandled", conn);
    cmd.CommandType = CommandType.StoredProcedure;
    conn.Open();
    try
    {
      SqlContext.Pipe.ExecuteAndSend(cmd);
      //cmd.ExecuteNonQuery();
    }
    catch (SqlException ex)
    {
      SqlCommand cmd2 = conn.CreateCommand();
      cmd2.CommandText = string.Format("raiserror(50001, 16, 1) with seterror");
      SqlContext.Pipe.ExecuteAndSend(cmd2);
    }
  }
};
