using System;
using System.Collections.Generic;
using System.Text;
using System.Text.RegularExpressions;
using System.Data;
using System.Data.SqlClient;

namespace ErrorTester
{
  class Program
  {
    static void Main(string[] args)
    {

      using (SqlConnection conn = new SqlConnection("server=.;integrated security=sspi;database=pubs"))
      using (SqlCommand cmd = new SqlCommand("error_wrapper_sqlclr4", conn))
      {
        cmd.CommandType = CommandType.StoredProcedure;
        try
        {
          conn.Open();
          int i = cmd.ExecuteNonQuery();
        }
        catch (SqlException sqlex)
        {
          Console.WriteLine("--------------- from SqlException ------------");
          Console.WriteLine("Error number: {0} Severity: {1} State: {2} Proc: {3} Line: {4}",
                  sqlex.Number, sqlex.Class, sqlex.State, sqlex.Procedure, sqlex.LineNumber);

          Console.WriteLine(sqlex.Message); Console.WriteLine();

          //ParseErrorWithRegex(sqlex);

          Console.WriteLine("---------------------------------------------");

          //ParseErrorCollection
          Console.WriteLine("Number of SqlErrors: {0}\n", sqlex.Errors.Count);
          for (int i=0;i<sqlex.Errors.Count;i++)
          {
            SqlError err = sqlex.Errors[i];
            Console.WriteLine("SqlError: {0} Severity: {1} State: {2} Proc: {3} Line: {4}",
              err.Number, err.Class, err.State, err.Procedure, err.LineNumber);
            Console.WriteLine(err.Message); Console.WriteLine();
          }

        }
        catch (Exception ex)
        {
          Console.WriteLine(ex.Message);
        }
        finally
        {
          // Application-specific cleanup
        }
      }
    }

    public static void ParseErrorWithRegex(SqlException sqlex)
    {
      // Simplest case - the message is all you get
      // Console.WriteLine(sqlex.Number);
      // Console.WriteLine(sqlex.Message);
      if (sqlex.Number == 50000)
      {
        Console.WriteLine(sqlex.Message);
        // parse this apart with regular expression or use substring
        Console.WriteLine(sqlex.Message.Substring(6, 3));

        Regex rx = new Regex(@"Error\s(?<e>\d+),\sLevel\s(?<l>\d+),\sState\s(?<s>\d+),\sProcedure\s(?<p>\w+),\sLine\s(?<ln>\d+),\sMessage:\s(?<m>.+)");
        Match ma = rx.Match(sqlex.Message);
        if (ma.Success)
        {
          string errorno = ma.Result("${e}");
          string level = ma.Result("${l}");
          string state = ma.Result("${s}");
          string proc = ma.Result("${p}");
          string line = ma.Result("${ln}");
          string message = ma.Result("${m}");
        }
        else
          Console.WriteLine("unparsable error");
         

        // Line number and procedure aren't right
        /*
        Console.WriteLine("severity: {0}",sqlex.Class);
        Console.WriteLine("line number: {0}",sqlex.LineNumber); // 28
        Console.WriteLine("procedure: {0}", sqlex.Procedure);   // usp_RethrowError
        */
      }
      else
        Console.WriteLine("Unexpected error: {0}", sqlex.Message);
    }
  }
}
