using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Text.RegularExpressions;
using System.Windows.Forms;
using System.Data.SqlClient;

namespace ShowErrors
{
  public partial class Form1 : Form
  {
    public Form1()
    {
      InitializeComponent();
    }

    private void button1_Click(object sender, EventArgs e)
    {
            using (SqlConnection conn = new SqlConnection("server=.;integrated security=sspi;database=pubs"))
      using (SqlCommand cmd = new SqlCommand(textBox1.Text, conn))
      {
        cmd.CommandType = CommandType.StoredProcedure;
        try
        {
          conn.Open();
          int i = cmd.ExecuteNonQuery();
        }
        catch (SqlException sqlex)
        {
          richTextBox1.Clear();
          richTextBox1.AppendText(String.Format("--------------- from SqlException ------------\n"));
          richTextBox1.AppendText(String.Format("Error number: {0} Severity: {1} State: {2} Proc: {3} Line: {4}\n",
                  sqlex.Number, sqlex.Class, sqlex.State, sqlex.Procedure, sqlex.LineNumber));

          richTextBox1.AppendText(String.Format("{0}\n\n",sqlex.Message)); 

          //ParseErrorWithRegex(sqlex);

          richTextBox1.AppendText(String.Format("---------------------------------------------\n"));

          //ParseErrorCollection
          richTextBox1.AppendText(String.Format("Number of SqlErrors: {0}\n\n", sqlex.Errors.Count));
          for (int i=0;i<sqlex.Errors.Count;i++)
          {
            SqlError err = sqlex.Errors[i];
            richTextBox1.AppendText(String.Format("SqlError: {0} Severity: {1} State: {2} Proc: {3} Line: {4}\n",
              err.Number, err.Class, err.State, err.Procedure, err.LineNumber));
            richTextBox1.AppendText(String.Format("{0}\n\n",err.Message));
          }

        }
        catch (Exception ex)
        {
          richTextBox1.AppendText(String.Format(ex.Message));
        }
        finally
        {
          // Application-specific cleanup
        }
      }
    }

    public void ParseErrorWithRegex(SqlException sqlex)
    {
      // Simplest case - the message is all you get
      // richTextBox1.AppendText(String.Format((sqlex.Number);
      // richTextBox1.AppendText(String.Format((sqlex.Message);
      if (sqlex.Number == 50000)
      {
        richTextBox1.AppendText(String.Format(sqlex.Message));
        // parse this apart with regular expression or use substring
        richTextBox1.AppendText(String.Format(sqlex.Message.Substring(6, 3)));

        Regex rx = new Regex(@"Error\s(?<e>\d+),\sLevel\s(?<l>\d+),\sState\s(?<s>\d+),\sProcedure\s(?<p>\w+),\sLine\s(?<ln>\d+),\sMessage:\s(?<m>.+)");
        Match ma = rx.Match(sqlex.Message);
        if (ma.Success)
        {
          string errorno = ma.Result("${e}");
          string level = ma.Result("${l}");
          string state = ma.Result("${s}");
          string proc = ma.Result("${p}");
          string line = ma.Result("${ln}");
          string message = ma.Result("${m}");
        }
        else
          richTextBox1.AppendText(String.Format("unparsable error"));


        // Line number and procedure aren't right
        /*
        richTextBox1.AppendText(String.Format("severity: {0}",sqlex.Class);
        richTextBox1.AppendText(String.Format("line number: {0}",sqlex.LineNumber); // 28
        richTextBox1.AppendText(String.Format("procedure: {0}", sqlex.Procedure);   // usp_RethrowError
        */
      }
      else
        richTextBox1.AppendText(String.Format("Unexpected error: {0}\n", sqlex.Message));
    }

    private void Form1_Load(object sender, EventArgs e)
    {

    }

  }
}